* hotlist manager
* Created 11-30-94

*set defa dxx to ..\prod
*set exclusive off
set exclusive on
set autolock on
SET DB3 OFF

close all
clear all
erase

set procedure to hotlist

okay = .t.
do chk_files with okay
if .not. okay
  set procedure to
  return
endif

select 1
use hotlist index ship_name, ship_flag alias hotlist

public pgdn_key, ctlw_key, esc_key 

* Some key codes
pgdn_key = 337
pgup_key = 329
ctlw_key = 23
esc_key = 27

public name_w, flag_w, fields

* get the field info of some fields

* get the width of name field
var = gvarinfo("hotlist->name")
name_w = extract(",", var, 3)
name_w = val(name_w)	&& Change to #

* get the width of flag field
var = gvarinfo("hotlist->flag")
flag_w = extract(",", var, 3)
flag_w = val(flag_w)

* Count the number of fields.  (Can be replaced with FCOUNT())
fields = 0
do while .t.
  if len(field(fields + 1)) = 0
    exit
  endif
  inc fields
enddo
windno = pushwind()
do while .t.
  popwind(windno)
  erase
  @ 1, 20 to 22, 55
  @ 3, 30 SAY "Hotlist Manager"
  choice = vmenu(',', 'ADD %!Add Vessels,Edit%!Edit ,Display%!;
Display/Edit database ,Search%!Search Vessel,List%!;
List/Print Vessel,Append dbf%!Append from a dbf file,SYSTEM%!;
CAUTION ** Use with care **,QUIT%!Exit program', 6, 1, 0, 2, 30)
  do case
    case choice = 1	&& Add
      do add_ves
    case choice = 2	&& Edit
      do edit_ves
    case choice = 3	&& Display/Edit/Delete Records
      do disp_ves
    case choice = 4	&& Search
      do srch_ves
    case choice = 5	&& List/Print
      do list_ves
    case choice = 6	&& Append from a database
      do app_dbf
    case choice = 7	&& System functions
      ?"Not implemented yet."
      exit
    case choice = 0	&& Esc or Quit
      exit
    case choice = 8	&& QUIT
      exit
  endcase
enddo
close all
set procedure to
return


*****************
procedure add_ves
* Add a vessel to the data base
*****************
set index to ship_name

do while .t.

  m->name = SPACE(name_w)
  m->flag = SPACE(flag_w)

  erase
  @  0,0 say "Add a Vessel Info"

  @  2,0 say "Vessel Name: " GET m->name PICTURE "@!";
	MESSAGE "Enter Vessel name. Press Esc to abort."
  @  3,0 say "Flag       : " GET m->flag PICTURE "@!";
	MESSAGE "Enter Flag. Press Esc to abort."
  READ
* Abort if Esc key is pressed
  if lastkey() = esc_key
    return
  endif

  choice = " "
  if len(trim(m->name)) = 0 .or. len(trim(m->flag)) = 0
    do dispmsg with "You must enter a vessel name and flag",;
"Press any key to continue", choice
    loop
  endif

  found = .f.
  do check_dup with m->name, m->flag, found
  if found
*** The SEEK cmd is successful. A record with same info exist ***
    do edit_rec
    if lastkey() = esc_key
      go current		&& abort the changes.  Do not update
    endif
  else
	** SEEK cmd is not successful.  Append a new rec.
    go 0	&& create a blank record
	* put the name, flag into the fields
    name = m->name
    flag = m->flag
    do edit_rec
    if lastkey() <> esc_key
      append record
    endif
  endif
enddo
return


*****************
procedure check_dup
* check if there is a duplicate record
*****************
parameter p_name, p_flag, found

* Check if a record with the same info exist
  found = .f.
  seek p_name
  if found()
    do while .not. eof() .and. p_name = name
* Find the vessel with the same flag
      if p_flag = flag
	found = .t.
	exit
      endif
      skip
    enddo
  endif
return


*****************
procedure edit_ves
* Edit a record
*****************
set index to ship_name

do while .t.

  m->name = SPACE(name_w)
  m->flag = SPACE(flag_w)

  erase
  @ 0,0 say "Edit a Vessel Info"

  @  2,0 say "Vessel Name: " GET m->name PICTURE "@!";
	MESSAGE "Enter Vessel name. Press Esc to abort."
  READ

* Abort if Esc key is pressed
  if lastkey() = esc_key
    return
  endif

* Check if a record with the same info exist
  seek m->name
  if found()
*** The SEEK cmd is successful. A record with same name exist ***
    do edit_rec
    if lastkey() = esc_key
      go current		&& abort the changes.  Do not update
    endif
  else
* SEEK failed.
    choice = " "
    do dispmsg with "The vessel : " + trim(m->name) + " does not exist.",;
"Press a key (Esc = Return to Menu, A = Add, any = Continue).", choice
    if lastkey() = esc_key
      return to hotlist
    endif
    if upper(choice) = "A"
      do add_ves
    endif
  endif
enddo
return



*****************
procedure edit_rec
* Edit a record
*****************

set message to "Press Esc = Quit, ^W = Save & exit, PgUp/PgDn = Prev/Next Rec"
erase
* Force the "name", "flag" to upper case
** Do not allow the name, flag fields to be changed
*@  0,0 SAY "Vessel Name: " GET name PICT "@!"
*@  1,0 SAY "Flag       : " GET flag PICT "@!"

@  0,0 SAY "Vessel Name: " SAY name PICT "@!"
@  1,0 SAY "Flag       : " SAY flag PICT "@!"
@  2,0 SAY "Home Port  : " GET homeport
@  3,0 SAY "Length     : " GET length
@  4,0 SAY "Vessel Type: " GET type
@  5,0 SAY "Hull       : " GET hull
@  6,0 SAY "Structure  : " GET sstruct
@  7,0 SAY "Look Out   : " GET lookout
@  8,0 SAY "Category   : " GET cat
@  9,0 SAY "DTG        : " GET dtg
@ 10,0 SAY "Source     : " GET source
@ 11,0 SAY "Memo       : " GET memo
date = date()	&& Today's date
@ 12,0 SAY "Date       : " GET date
READ
return


*****************
procedure disp_ves
* Display the database
*****************
do while .t.
  erase
  @ 1, 20 to 20, 65
  @ 3, 30 SAY "Display/Edit/Delete the database"
  choice = vmenu(',', 'Order By Name %!Order by Vessel name;
,Order by Flag%!Order by Flag,QUIT%!Exit Search', 6, 1, 0, 2, 30)
  do case
    case choice = 1	&& by Name
      set index to ship_name
    case choice = 2	&& by Flag
      set index to ship_flag
    case choice = 3	&& Quit
      exit
    case choice = 0	&& Esc or Quit
      exit
  endcase
  GO TOP
  browse noappend
enddo
return


*****************
procedure srch_ves
* Search for  a Vessel
*****************
do while .t.
  erase
  @ 1, 20 to 20, 65
  @ 3, 30 SAY "Search a Vessel"
  choice = vmenu(',', 'By Name %!Search a Vessel by name;
,By Flag%!Search a Vessel by Flag,QUIT%!Exit Search', 6, 1, 0, 2, 30)
  do case
    case choice = 1	&& by Name
      do srch_name
    case choice = 2	&& by Flag
      do srch_flag
    case choice = 3	&& Quit
      exit
    case choice = 0	&& Esc or Quit
      exit
  endcase
enddo
return


*****************
procedure srch_name
*Search Vessel by name
*****************

set index to ship_name

do while .t.
  erase
  m->name = SPACE(name_w)

  @  0,0 SAY "Search a Vessel by Name"
  @  2,0 say "Vessel Name: " GET m->name PICTURE "@!";
	MESSAGE "Enter Vessel name. Press Esc to abort."
  READ

* Abort if Esc key is pressed
  if lastkey() = esc_key
    return
  endif

  seek trim(m->name)
  if found()
    browse noappend
  else
    choice = " "
    do dispmsg with   "The vessel : " + trim(m->name) + " does not exist.",;
"Press a key to continue", choice
  endif
enddo
return


*****************
procedure srch_flag
*Search Vessel by Flag
*****************

set index to ship_flag

do while .t.
  erase
  m->flag = SPACE(flag_w)

  @  0,0 SAY "Search a Vessel by Flag"
  @  2,0 say "Flag       : " GET m->flag PICTURE "@!";
	MESSAGE "Enter Flag. Press Esc to abort."
  READ

* Abort if Esc key is pressed
  if lastkey() = esc_key
    return
  endif

  seek trim(m->flag)
  if found()
    browse noappend
  else
    choice = " "
    do dispmsg with "There is no vessel with the " + trim(m->flag);
	+ " flag.","Press a key to continue", choice
  endif
enddo
return


*****************
procedure list_ves
* List/Print vessel info
*****************
private scope_ph, for_ph, fields_ph, print_ph
private choice
private list

store " " to scope_ph, for_ph, fields_ph, print_ph, list
store " " to choice

pushwind()
erase

window(2, 3, 6, 75)
erase

list = "LIST"
@ 2, 0 SAY list

DO getscope with scope_ph
list = list + scope_ph

@ 2, 0 SAY list

DO getfor with for_ph
list = list + for_ph
@ 2, 0 SAY list

DO getfldls with 80, fields_ph
if len(fields_ph) <> 0
  list = list + " FIELDS" + fields_ph
  @ 2, 0 SAY list
endif

DO getvmenu with 5, 20, "Print on", 'Screen|Printer', choice

print_ph = .f.
DO CASE
  CASE choice = 2  | Print on printer
    print_ph = .t.
ENDCASE
popwind()
do dispdbf with scope_ph, for_ph, fields_ph, print_ph
RETURN	| End of lstrec


*****************
PROCEDURE GETSCOPE
* Get a scope phrase
* Usage:
*	do getscope with phrase
* The scope phrase is returned in phrase
*****************
parameter phrase
private get_var, choice

store 0 to get_var, choice

vmenu_txt = 'All records|Record # (Just One)|Current record|;
Next N records|Rest of the file'
DO getvmenu with 8, 38, 'Please Select a Scope', vmenu_txt, choice
DO CASE
    CASE choice = 1 | ALL
      phrase = 'ALL'
    CASE choice = 2 | RECORD
      get_var = 0
      do getread with 5, 40, 'Please enter the record number',;
	'@ 3, 16 get get_var PICT "########"'
      phrase = 'RECORD '+ LTRIM(STR(get_var, 6))
    CASE choice = 3 | Current record
      phrase = ""
    CASE choice = 4 | Next N record
      get_var = 0
      do getread with 5, 40, 'Please enter the number of records',;
	'@ 3, 16 get get_var PICT "########"'
      phrase = 'NEXT '+ LTRIM(STR(get_var, 5))
    CASE choice = 5 | REST
	phrase = 'REST'
  ENDCASE
phrase = ' ' + phrase
RETURN


*****************
PROCEDURE GETFOR
* Get a FOR expression
* Usage:
*	do getfor with phrase
* The FOR phrase is returned in phrase
*****************
parameter phrase

private for_ph
private choice, for_len

phrase = ""

for_len = 60
store " " to for_ph
choice = 0

DO GETVMENU with 8, 38, 'Create a FOR Selection ?', 'No|Yes', choice

IF choice = 1
  RETURN
ENDIF

do getlexp with "Create a FOR selection", for_len, for_ph

if len(trim(for_ph)) <> 0
  phrase = ' FOR' + for_ph
endif
return


*****************
PROCEDURE getfldls
* Get a list of field names
* Usage:
*	do getfldls with list_len, phrase
* The list of field names is is returned in phrase
*****************
parameter list_len, phrase

private choice
private list, fldname, type, width, decimal

store 0 to choice
store " " to list, fldname, type, width, decimal
phrase = ""

DO GETVMENU with 8, 40, "Create a list of fields",;
	 'ALL fields|Selected fields', choice
IF choice <> 2
  return
endif

pushwind()
window(5, 10, 15, 70)
erase

list = ""

@ 0,0 SAY center("Create a list of fields", 60)

@ 2, 0 SAY "Field list : "
DO getfield with fldname, type, width, decimal

list = list + fldname
@ 2, 13 SAY list

DO while .T.
  DO getvmenu with 5, 30, 'Select more fields?', "Yes|No", choice
  IF choice = 2	&& No more field to select
    EXIT
  ENDIF
  if len(list) > list_len
    do dispmsg with "The list is too long", "Press a key to continue", choice
    exit
  endif
  DO getfield with fldname, type, width, decimal
  list = list + ", " + fldname
  @ 2, 13 SAY list
ENDDO

popwind()
phrase = " " + list
return



*****************
procedure getlexp
* Get a logical expression
* Usage:
*	do getlexp with title, exp_len, phrase
* The expression is returned in phrase
*****************
parameter title, exp_len, phrase

store " " to phrase, lexp

pushwind()
window(3, 5, 7, 70)
erase

exp = ""
@ 0, 0 SAY center(title, 65)
@ 2, 0 SAY exp

DO getlexp1 with lexp
exp = exp + lexp
@ 2, 0 SAY exp

DO WHILE LEN(TRIM(exp)) < exp_len

  DO getvmenu with 8, 32, 'Create a Selection';
	,'No further selection|Continue with AND|Continue with OR', choice

  DO CASE
    CASE choice = 1
      EXIT
    CASE choice = 2
      exp = exp + ' .AND.'
    CASE choice = 3
      exp = exp + ' .OR.'
  ENDCASE

  @ 2, 0 SAY exp
  DO getlexp1 with lexp

  exp = exp + lexp
  @ 2, 0 SAY exp

ENDDO

phrase = " " + exp

popwind()
RETURN | End of getlexp


*****************
PROCEDURE GETLEXP1
* Get a logical expression
* Usage:
*	do getlexp with phrase
* The expression is returned in phrase
*****************
parameter phrase

private operator, value, exp
private fldname, type, width, decimal

store " " to fldname, type, width, decimal
store 0 to operator, value

exp = ""

pushwind()
window(5, 5, 9, 70)
erase

phrase = ""

@ 2, 0 SAY "Exp : "

DO getfield with fldname, type, width, decimal

choice = " "

if type = 'M'
  do dispmsg with "Memo field is not allowed", "Press any key.", choice
  popwind()
  return
endif

exp = fldname
@ 2, 6 ESAY exp

if type = 'N' .or. type = 'C' .or. type = 'D'

  DO getrelop with operator
  exp = trim(exp) + operator
  @ 2, 6 ESAY exp
endif

DO getvalue with value, type, width, decimal
exp = trim(exp) + value
@ 2, 6 ESAY exp

phrase = ' ' + exp

popwind()

RETURN | End of getlexp


*****************
PROCEDURE GETFIELD
* Usage:
*	do getfield with fldname, type, width, decimal
* Get one field name
* returns the field name, type, width and decimal
*****************
parameter fldname, type, width, decimal

pushwind()
fldinfo = FMENU( 2, 5, 11, 4)
fldname = extract(",", fldinfo, 1)
type = extract(",", fldinfo, 2)
width = extract(",", fldinfo, 3)
decimal = extract(",", fldinfo, 4)
popwind()

RETURN | End of getfield


*****************
PROCEDURE GETRELOP
* Usage:
*	do getrelop with operator
* Get a relational operator
*****************
parameter operator

vmenu_text = '=  Equal To|<= Less Than or Equal To|<  Less Than|>  Greater Than|>= Greater Than or Equal To|<> Not Equal To|Like (strings only)'

choice = " "

DO GETVMENU with 8, 30, 'Please select an operator', vmenu_text, choice
DO CASE
    CASE choice = 1
      operator = ' ='
    CASE choice = 2
      operator = ' <='
    CASE choice = 3
      operator = ' <'
    CASE choice = 4
      operator = ' >'
    CASE choice = 5
      operator = ' >='
    CASE choice = 6
      operator = ' <>'
    CASE choice = 7
      operator = ' LIKE'
ENDCASE
RETURN | End of getrelop



*****************
PROCEDURE getvalue
* Usage:
*	do getvalue with value, type, width, decimal
* get a literal value for the data type, width and decimal
* the value is returned in value
*****************
parameter value, type, width, decimal

choice = " "
DO CASE
  CASE type = 'C'
      get_var = SPACE(20)
      DO GETREAD with 6, 40, 'Enter a character string',;
	"@ 3, 2 GET get_var"
      get_var = trim(get_var)
	* check for single/double quotes
      if srch("'", get_var) = 0 .and. srch('"', get_var) = 0 
	get_var = '"' +  get_var + '"'	&& enclose in quotes
      endif
      get_var = ' ' + get_var
  CASE type = 'D'
      get_var = {//}
      DO GETREAD with 6, 40, 'Please enter a DATE.',;
	"@ 3, 15 GET get_var"
      get_var =  ' {' + DTOC(get_var)+'}'
  CASE type = 'N'
	* create a PICTURE
    GET_PIC = DUPCHAR(35, width + 1) | PICTURE FOR GETING NUMBER
    GET_PIC = MIDSTR('.', GET_PIC, (width - decimal) +1)
    get_var =  VAL(STR(0, width, decimal))
    DO GETREAD with 8, 40, 'Please enter a NUMBER.',;
	 '@ 3,0 GET get_var PICTURE get_pic'
    get_var = ' ' + LTRIM(STR(get_var, width, decimal))
  CASE type = 'L'
    vmenu_text = ' = Yes/True| = No/False'
    DO GETVMENU with 8, 13, 'Please select',vmenu_text, choice
    if choice = 1
      get_var = " = .T."
    endif
    if choice = 2
      get_var = " = .F."
    endif
ENDCASE
value = get_var
RETURN | End of getvalue


*****************
PROCEDURE getvmenu
* Usage:
*	do getvmenu with rows, cols, title, vmenu_txt, choice
* Select an item from a vertical menu
* rows, cols # of rows/cols in the window
* title Title of the menu
* vmenu_txt menu items
* choice the result of the selection
*****************
parameter rows, cols, title, vmenu_txt, choice

pushwind()

row = srowmax() - rows
row = row /2
col = scolmax() - cols
col = col /2

window(row, col, row + rows, col + cols)
erase

@ 0, 0 SAY CENTER(title, cols)
cancel_no = TOKENS('|', vmenu_txt) + 2
VMENU('|', vmenu_txt + '|Cancel', 2, 1, 0, 1, -1)
popwind()
if vmenu() = cancel_no
  return to hotlist
endif
choice = vmenu()
return


*****************
PROCEDURE getread
* Usage:
*	do getread with rows, cols, prompt, getcmd
* rows, cols # of rows/cols in the window
* prompt is the message to display
* getcmd is the GET cmd to use
*****************
parameter rows, cols, prompt, getcmd

pushwind()
row = srowmax() - rows
row = row /2
col = scolmax() - cols
col = col /2
window(row, col, row + rows, col + cols)
erase

@ 0, 0 SAY CENTER(prompt, cols)
&getcmd
read
popwind()
return



*****************
PROCEDURE dispmsg
* Usage:
*	do dispmsg with msg1, msg2, choice
* displays two lines of message and WAITs for a key
* msg1 and msg2 are two message lines displayed
* The key pressed is returned in choice
*****************
parameter msg1, msg2, choice

pushwind()
len1 = len(msg1)
len2 = len(msg2)

maxlen = len1
if len1 < len2
  maxlen = len2
endif
maxlen = maxlen + 2
* create a window
cols = scolmax() + 1
rows = srowmax() + 1
row = rows - 4
row = row /2
col = cols - maxlen
col = col /2
window(row, col, rows - row, cols - col)
erase
@ 1, 1 SAY msg1
@ 2, 1 SAY msg2
char = " "
wait to char
choice = char
popwind()
return


* display the records which satifies the "scope" and "for <condition>"

*****************
PROCEDURE DISPDBF
* Usage:
*	do dispdbf with scope_ph, for_ph, fields_ph, print
* scope_ph is the SCOPE phrase
* for_ph is the FOR phrase
* fields_ph is the list of fields to list
* print is a flag.  .T. = print., .F. = display on the screen
*
* Example:
*  DO DISPDBF WITH "ALL", "FOR vessel = 'GREEN'", "vessel_no, vessel_id", .t.

* fields_ph is the list of fields to display. "ALL" displays all the
* fields of the current record

* Many improvements can be made to speed up the process.
* for example, if an index file is used and the "for_ph" is the key
* of the index file, you can first SEEK to the first record which
* satisfies the condition and then use LOCATE REST.
* Or if the scope is known, then we can reduce and limit the amount of
* time used to process the last record.
* If the scope is "ALL" then it will traverse the entire database.
*****************
  parameter scope_ph, for_ph, fields_ph, print

if print
 set print on	&& if you want to output to the printer
endif
* set console off	&& if you do not wish to display the data
			&& on the screen
  locate &scope_ph &for_ph
  do while found()
    do disprec with fields_ph
* Output a <CR><LF>. Add a few more of ?'s to separate from the last records
    ?
    continue
  enddo

if print
  print spool
  set print off
endif
* set console on
return


*****************
PROCEDURE DISPREC
* Displays the fields in the list
* Usage:
*	do disprec with fieldlist
* fieldlist is the list of field names.  If fieldlist is "ALL" all the fields
* of the current record is displayed.
* Example:
* 	DO DISPREC WITH "CFIELD,IFIELD"
* Displays the contents of CFIELD and IFIELD fields
* 	DO DISPREC WITH "ALL"
* Displays all the fields of the current record
* memo_width is the width of memo data to display
*****************
  parameter fieldlist

  private dbm_all, dbm_info, dbm_fld, dbm_type, dbm_i1
  private memo_width, dbm_lineno, dbm_wwrap, dbm_tab, dbm_lcnt

  memo_width = 45	&& width of memo data to display. chg this if you need
			&& it wider or narrower.  You can also make this
			&& as a parameter.

  dbm_all = .f.
  if upper(fieldlist) = "ALL"
    dbm_all = .t.
  endif

  dbm_i1 = 1
  do while .t.
    if dbm_all
      dbm_info = field(dbm_i1)	&& get the next field info
      dbm_fld = extract(',', dbm_info, 1)	&& get the field name
      dbm_type = extract(',', dbm_info, 2)	&& get the field type
    else
      dbm_fld = extract(',', fieldlist, dbm_i1)	&& get the next field name
      dbm_type = fieldtype(dbm_fld)	&& get the field type
    endif
    inc dbm_i1
    if len(dbm_fld) = 0
	exit
    endif
    if dbm_type = 'U'
	* Bad field name
      ? dbm_fld, " : ", "Bad name"
    endif
    if dbm_type = 'M'
	* Memo field
      ? dbm_fld, " : "
      dbm_lineno = 1
      dbm_wwrap = .t.
      dbm_tab = 8
      dbm_lcnt = mlcount(&dbm_fld, memo_width)
      do while dbm_lcnt <> 0
        memodata = memoline(&dbm_fld, memo_width, dbm_lineno, dbm_tab,;
		dbm_wwrap)
        ?memodata
        dec dbm_lcnt
	inc dbm_lineno
      enddo
      loop
    endif
    ? dbm_fld, " : ", &dbm_fld
  enddo
return


*****************
procedure app_dbf
* Append the main database from another database
*****************

* get the name of the dbf file

get_var = SPACE(20)
DO GETREAD with 6, 40, 'Enter the file name to append from',;
	"@ 3, 10 GET get_var"
get_var = trim(get_var)
get_var = upper(get_var)
if at(".DBF", get_var) = 0
  get_var = get_var + ".DBF"	&& add extension
endif
choice = " "
if .not. file(get_var)
* Cannot find the file
  do dispmsg with "Cannot find " + get_var,;
"Press any key to continue", choice
  return
endif
append from &get_var
return


*****************
procedure chk_files
* Check if the hotlist database files exist
* Usage:
*	do chk_files with okflag
* return okflag = .t. if all the files exist.
*****************
parameter okflag

okflag = .f.
choice = " "
if .not. file("hotlist.dbf")
  do dispmsg with "hotlist.dbf does not exist.",;
	"Do you want to create the file? (Y/N) ", choice
  if upper(choice) = "Y"
    do credbf
    do crendx
    okflag = .t.
    return
  endif
  return
endif

if .not. file("ship_name.ndx")
  do dispmsg with "ship_name.ndx does not exist.",;
	"Do you want to create the file? (Y/N) ", choice
  if upper(choice) = "Y"
    do crendx
    okflag = .t.
    return
  endif
  return
endif

if .not. file("ship_flag.ndx")
  do dispmsg with "ship_flag.ndx does not exist.",;
	"Do you want to create the file? (Y/N) ", choice
  if upper(choice) = "Y"
    do crendx
    okflag = .t.
    return
  endif
  return
endif
okflag = .t.
return


*****************
procedure credbf
* Create the hotlist database
*****************
* create the dbf files for the hotlist manager

set db3 off
close all
delete file hotlist.dbf
delete file hotlist.dbt
delete file temp.dbf

create structure to temp
use temp
append blank
FIELD_NAME = "NAME"
FIELD_TYPE = "C"
FIELD_LEN = 20
FIELD_DEC = 0

append blank
FIELD_NAME = "FLAG"
FIELD_TYPE = "C"
FIELD_LEN = 15
FIELD_DEC = 0

append blank
FIELD_NAME = "HOMEPORT"
FIELD_TYPE = "C"
FIELD_LEN = 25
FIELD_DEC = 0

append blank
FIELD_NAME = "LENGTH"
FIELD_TYPE = "C"
FIELD_LEN = 8
FIELD_DEC = 0

append blank
FIELD_NAME = "TYPE"
FIELD_TYPE = "C"
FIELD_LEN = 5
FIELD_DEC = 0

append blank
FIELD_NAME = "HULL"
FIELD_TYPE = "C"
FIELD_LEN = 10
FIELD_DEC = 0

append blank
FIELD_NAME = "SSTRUCT"
FIELD_TYPE = "C"
FIELD_LEN = 10
FIELD_DEC = 0

append blank
FIELD_NAME = "LOOKOUT"
FIELD_TYPE = "C"
FIELD_LEN = 9
FIELD_DEC = 0

append blank
FIELD_NAME = "CAT"
FIELD_TYPE = "C"
FIELD_LEN = 6
FIELD_DEC = 0

append blank
FIELD_NAME = "DTG"
FIELD_TYPE = "C"
FIELD_LEN = 15
FIELD_DEC = 0

append blank
FIELD_NAME = "SOURCE"
FIELD_TYPE = "C"
FIELD_LEN = 18
FIELD_DEC = 0

append blank
FIELD_NAME = "MEMO"
FIELD_TYPE = "M"
FIELD_LEN = 8
FIELD_DEC = 0

append blank
FIELD_NAME = "DATE"
FIELD_TYPE = "D"
FIELD_LEN = 8
FIELD_DEC = 0

CLOSE
create hotlist from temp
CLOSE all
delete file temp.dbf
return


*****************
procedure crendx
* Create the index files for hotlist database
*****************
* create the ndx files for hotlist manager
close all
delete file ship_name.ndx
delete file ship_flag.ndx

set exclu on

use hotlist
index on name to ship_name
index on flag to ship_flag

close all
set exclu off
return


